### dataset --------------------------------------------------------------------
# clean and format raw data
source('./01_01_CrisisLexT26_prepare.R', echo=FALSE)
source('./01_02_CrisisLexT6_prepare.R',  echo=FALSE)
source('./01_03_AIDR2015Q2_prepare.R',   echo=FALSE)
# balance classes
source('./01_04_balance.R', echo=FALSE)

### corpora --------------------------------------------------------------------
source('./02_01_corpora.R', echo=FALSE)

### compare models -------------------------------------------------------------
source('./03_01_svm.R') # SVM
source('./03_02_lda.R') # sLDA
# the best one is SVM, train on full dataset
source('./03_03_svm_full.R')

# The result is:
# * SVM-model (file `./saved/model.final.rds`)
# * vocabulary (file `./saved/vocabulary.rds`)

### train dataset size ---------------------------------------------------------
# precalculate - execute several time for more precise result
source('./04_02_trainset_size_svm.R') # SVM
source('./04_03_trainset_size_lda.R') # sLDA
# plots - use button "previous plot" in RStudio to see 3 plots:
source('./04_01_trainset_size.R')
