-- View: ibtracs_w34

-- DROP VIEW ibtracs_w34;

CREATE OR REPLACE VIEW ibtracs_w34 AS 
 SELECT min(radii_34.gid) AS gid
      , radii_34.serial_num
      , max(radii_34.name::text) AS name
      , min(radii_34.iso_time) AS date_start
      , max(radii_34.iso_time) AS date_end
      , st_union(
          st_makevalid(
            geometry(
              st_buffer(
                geography(radii_34.geom),
                (radii_34.w34_max * 1852)::double precision
        )))) AS geom
   FROM (
          SELECT ibtracs_all_points.gid
               , ibtracs_all_points.serial_num
               , ibtracs_all_points.name
               , ibtracs_all_points.iso_time::timestamp without time zone AS iso_time
               , GREATEST(
                   ibtracs_all_points.atc_w34_r1, ibtracs_all_points.atc_w34_r2, ibtracs_all_points.atc_w34_r3, ibtracs_all_points.atc_w34_r4, 
                   ibtracs_all_points.jtx_w34_r1, ibtracs_all_points.jtx_w34_r2, ibtracs_all_points.jtx_w34_r3, ibtracs_all_points.jtx_w34_r4
                 ) AS w34_max
               , ibtracs_all_points.geom
           FROM ibtracs_all_points
        ) radii_34
  WHERE radii_34.w34_max > 0
  GROUP BY radii_34.serial_num;
