import sys
import simplejson as json
import re

re_date = re.compile('^.{3} (.{6}) (.{8}) .{5} (.{4})$')

# csv header
sys.stdout.write('tweet_id,created_at,coordinates,hashtags,message\n')

i = 0
for line in sys.stdin:

	if line[0:5] == '{"del':
		#sys.stdout.write('skip...\n')
		continue
	
	try:
		data = json.loads(line)
	except:
		sys.stdout.write('json error!\n')
		sys.stdout.write('\n')
		sys.stdout.write('line')
		sys.stdout.write('\n')
		break

	if 'lang' not in data: continue
	if data['lang'] != 'en': continue

	if 'retweeted_status' in data:
		data = data['retweeted_status']

	#i += 1
	#if i > 1000: break

	tweet_id   = data['id']
	tweet_date = data['created_at']
	tweet_geom = data['coordinates'] if data['coordinates'] is not None else ''
	tweet_hash = data['entities']['hashtags']
	tweet_text = data['text']

	tweet_date = re_date.sub('\g<1> \g<3> \g<2> UTC', tweet_date)

	tweet_geom = json.dumps(json.dumps(tweet_geom)) if len(tweet_geom) > 0 else ''

	if len(tweet_hash) > 0:
		tweet_hash = [ x['text'] for x in tweet_hash ]
		tweet_hash = ','.join(tweet_hash)
		tweet_hash = '{' + tweet_hash + '}'
	else:
		tweet_hash = ''

	tweet_text = tweet_text.replace('\n', ' ')
	tweet_text = tweet_text.replace('"', '\\"')

	record = '{};"{}";{};{};"{}"'.format(tweet_id, tweet_date, tweet_geom, tweet_hash, tweet_text)
	sys.stdout.write(record)
	sys.stdout.write('\n')
