------[ coordinates-to-geo ]-----------------------------------------------------------
UPDATE tweets_upload -- 3 minutes (1 month) / 114 minutes (3 months)
   SET geom = ST_GeomFromGeoJSON(coordinates)
 WHERE coordinates IS NOT NULL;

------[ drop indices ]-----------------------------------------------------------------
DROP INDEX tweets_date_idx; -- 22 s
DROP INDEX tweets_fts_idx;
DROP INDEX tweets_geom_idx;
DROP INDEX tweets_hashtags_idx;
ALTER TABLE tweets DROP CONSTRAINT tweets_pkey;

------[ move from `upload` to the main table ]-----------------------------------------
INSERT INTO tweets -- 6 hours
SELECT DISTINCT ON (tweet_id)
       tweet_id
     , created_at
     , geom
     , hashtags
     , message
  FROM tweets_upload AS new
 WHERE NOT EXISTS (
         SELECT 1 
           FROM tweets
          WHERE tweets.tweet_id = new.tweet_id
       )

-- DROP TABLE tweets_upload;

------[ add indexes ]------------------------------------------------------------------
ALTER TABLE tweets ADD CONSTRAINT tweets_pkey PRIMARY KEY(tweet_id); -- 14 minutes
CREATE INDEX tweets_date_idx     ON tweets USING btree (created_at); -- 14 minutes
CREATE INDEX tweets_fts_idx      ON tweets USING GIN (to_tsvector('english', message)); -- 3.5 hours
CREATE INDEX tweets_geom_idx     ON tweets USING GIST (geom); -- 47 minutes
--CREATE INDEX tweets_hashtags_idx ON tweets USING btree (hashtags); -- 35 minutes
CREATE INDEX tweets_hashtags_idx ON tweets USING GIN (hashtags);
ANALYZE tweets; -- 4 minutes
